#!/bin/sh
#
#
# SIROCCO
# Copyright (C) 2011 France Telecom
# Contact: sirocco@ow2.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
#  $Id: vmmcontrol.sh 28 2011-06-20 12:40:15Z dangtran $
#
#


cygwin=false;
case "`uname`" in
  CYGWIN*) cygwin=true;
esac

if [ -z $VMM_HOME ]
then
  savewd=`pwd`
  cd `dirname $0`
  zdir=`pwd`
  cd $savewd
  VMM_HOME=`dirname $zdir`
  export VMM_HOME
fi



if [ -z "$JAVA_HOME" ]
then
    JAVA=java
else
    JAVA="$JAVA_HOME/bin/java"
fi

CLASSPATH=$VMM_HOME/etc:$VMM_HOME/lib:$VMM_HOME/lib/sirocco-vmm-agent.jar


if $cygwin; then
  CLASSPATH=`cygpath --path -w $CLASSPATH`
  VMM_HOME=`cygpath --path -w $VMM_HOME`
fi

JAVA_OPTS=-Dvmm.home="$VMM_HOME"

MODE=
ARGS=
START_OPTS=

while [ "$#" -gt 0 ]
  do case "$1" in
    start)
      MODE=start
      ;;
    stop)
      MODE=stop
      ;;
    *)
      ARGS="$ARGS $1"
      ;;
  esac
  shift
done

case "$MODE" in
  start)
    START_OPTS="-start"
    BACKGROUND=true;
    ;;
  stop)
    START_OPTS="-stop"
    ;;
  *)
    echo "Usage: $0 start | stop"
 	exit 1
    ;;
esac


if [ -n $BACKGROUND ]; then
"$JAVA"  $JAVA_OPTS -cp $CLASSPATH org.ow2.sirocco.vmm.agent.main.AgentControl $START_OPTS $ARGS &
else
"$JAVA"  $JAVA_OPTS -cp $CLASSPATH org.ow2.sirocco.vmm.agent.main.AgentControl $START_OPTS $ARGS
fi
