#!/bin/bash
#
#
# SIROCCO
# Copyright (C) 2011 France Telecom
# Contact: sirocco@ow2.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
#  $Id: customizeGuestOS.sh 205 2011-07-27 10:09:50Z dangtran $
#
#


usage() {
cat << EOF
usage: $0 options

OPTIONS:
  --disk disk image absolute path
  --net customization option for network interface: Iface / mode / ip / netmask / gateway
  --hostname customization option : new Hostname of the VM
  --sshkey root public ssh key to install on the guest OS
  --userdata key value
EOF
}

disk=
hostname=
sshkey=
net=

while [[ -n $1 ]]; do
        case "$1" in
                disk)
                disk="$2"
                shift 2
                ;;

                net)
                net="$2"
                shift 2
                ;;

                hostname)
                hostname="$2"
                shift 2
                ;;

                sshkey)
                sshkey=$2
                shift 2
                ;;

                userdata)
                echo $2 $3 >> /tmp/userdata-$$.cfg
                shift 3
                ;;

                *)
                usage
                exit 1
                ;;
  esac
done

if [[ -z $disk ]]
then
     usage
     exit 1
fi


rootFS=`virt-list-filesystems -a $disk | head -n 1`

if virt-cat  $disk  /etc/dhcp/dhclient.conf  > /dev/null 2>&1
then
        dhdir=dhcp
else
        dhdir=dhcp3
fi


commands=/tmp/command$$

echo "add $disk" >> $commands
echo "run" >> $commands
echo "mount $rootFS /" >> $commands

if [[ -n $hostname ]]
then
        echo "write-file  /etc/hostname \"${hostname}\" 0 " >> $commands
        echo "download /etc/$dhdir/dhclient.conf /tmp/dhclient-$$.conf" >> $commands
        echo "! sed -i "s/HOSTNAME/$hostname/g" /tmp/dhclient-$$.conf " >> $commands
        echo "upload /tmp/dhclient-$$.conf /etc/$dhdir/dhclient.conf " >> $commands
fi
            

if [[ -n $sshkey ]]
then            
        echo "mkdir /root/.ssh" >> $commands
        echo "write-file /root/.ssh/authorized_keys2 \"${sshkey}\" 0 " >> $commands
fi

if [[ -e /tmp/userdata-$$.cfg ]]
then
        echo "$command upload /tmp/userdata-$$.cfg /etc/userdata.cfg " >> $commands
fi   
     
guestfish < $commands
rm $commands
rm -f /tmp/userdata-$$.cfg

                